242 lines
7.7 KiB
Diff
242 lines
7.7 KiB
Diff
From a4a984e67e276e643b8a51f39ca426d0967754a0 Mon Sep 17 00:00:00 2001
|
|
From: Max Reitz <mreitz@redhat.com>
|
|
Date: Mon, 13 Jul 2020 14:24:51 -0400
|
|
Subject: [PATCH 4/4] iotests/026: Move v3-exclusive test to new file
|
|
MIME-Version: 1.0
|
|
Content-Type: text/plain; charset=UTF-8
|
|
Content-Transfer-Encoding: 8bit
|
|
|
|
RH-Author: Max Reitz <mreitz@redhat.com>
|
|
Message-id: <20200713142451.289703-5-mreitz@redhat.com>
|
|
Patchwork-id: 97956
|
|
O-Subject: [RHEL-8.3.0 qemu-kvm PATCH 4/4] iotests/026: Move v3-exclusive test to new file
|
|
Bugzilla: 1807057
|
|
RH-Acked-by: Stefano Garzarella <sgarzare@redhat.com>
|
|
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
RH-Acked-by: Kevin Wolf <kwolf@redhat.com>
|
|
|
|
data_file does not work with v2, and we probably want 026 to keep
|
|
working for v2 images. Thus, open a new file for v3-exclusive error
|
|
path test cases.
|
|
|
|
Fixes: 81311255f217859413c94f2cd9cebf2684bbda94
|
|
(“iotests/026: Test EIO on allocation in a data-file”)
|
|
Signed-off-by: Max Reitz <mreitz@redhat.com>
|
|
Message-Id: <20200311140707.1243218-1-mreitz@redhat.com>
|
|
Reviewed-by: John Snow <jsnow@redhat.com>
|
|
Tested-by: John Snow <jsnow@redhat.com>
|
|
Signed-off-by: Max Reitz <mreitz@redhat.com>
|
|
(cherry picked from commit c264e5d2f9f5d73977eac8e5d084f727b3d07ea9)
|
|
|
|
Conflicts:
|
|
tests/qemu-iotests/group
|
|
- As per usual.
|
|
|
|
Signed-off-by: Max Reitz <mreitz@redhat.com>
|
|
Signed-off-by: Danilo C. L. de Paula <ddepaula@redhat.com>
|
|
---
|
|
tests/qemu-iotests/026 | 31 -----------
|
|
tests/qemu-iotests/026.out | 6 --
|
|
tests/qemu-iotests/026.out.nocache | 6 --
|
|
tests/qemu-iotests/289 | 89 ++++++++++++++++++++++++++++++
|
|
tests/qemu-iotests/289.out | 8 +++
|
|
tests/qemu-iotests/group | 1 +
|
|
6 files changed, 98 insertions(+), 43 deletions(-)
|
|
create mode 100755 tests/qemu-iotests/289
|
|
create mode 100644 tests/qemu-iotests/289.out
|
|
|
|
diff --git a/tests/qemu-iotests/026 b/tests/qemu-iotests/026
|
|
index c1c96a41d9..3afd708863 100755
|
|
--- a/tests/qemu-iotests/026
|
|
+++ b/tests/qemu-iotests/026
|
|
@@ -237,37 +237,6 @@ $QEMU_IO -c "write 0 $CLUSTER_SIZE" "$BLKDBG_TEST_IMG" | _filter_qemu_io
|
|
|
|
_check_test_img
|
|
|
|
-echo
|
|
-echo === Avoid freeing external data clusters on failure ===
|
|
-echo
|
|
-
|
|
-# Similar test as the last one, except we test what happens when there
|
|
-# is an error when writing to an external data file instead of when
|
|
-# writing to a preallocated zero cluster
|
|
-_make_test_img -o "data_file=$TEST_IMG.data_file" $CLUSTER_SIZE
|
|
-
|
|
-# Put blkdebug above the data-file, and a raw node on top of that so
|
|
-# that blkdebug will see a write_aio event and emit an error
|
|
-$QEMU_IO -c "write 0 $CLUSTER_SIZE" \
|
|
- "json:{
|
|
- 'driver': 'qcow2',
|
|
- 'file': { 'driver': 'file', 'filename': '$TEST_IMG' },
|
|
- 'data-file': {
|
|
- 'driver': 'raw',
|
|
- 'file': {
|
|
- 'driver': 'blkdebug',
|
|
- 'config': '$TEST_DIR/blkdebug.conf',
|
|
- 'image': {
|
|
- 'driver': 'file',
|
|
- 'filename': '$TEST_IMG.data_file'
|
|
- }
|
|
- }
|
|
- }
|
|
- }" \
|
|
- | _filter_qemu_io
|
|
-
|
|
-_check_test_img
|
|
-
|
|
# success, all done
|
|
echo "*** done"
|
|
rm -f $seq.full
|
|
diff --git a/tests/qemu-iotests/026.out b/tests/qemu-iotests/026.out
|
|
index c1b3b58482..83989996ff 100644
|
|
--- a/tests/qemu-iotests/026.out
|
|
+++ b/tests/qemu-iotests/026.out
|
|
@@ -653,10 +653,4 @@ wrote 1024/1024 bytes at offset 0
|
|
1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
write failed: Input/output error
|
|
No errors were found on the image.
|
|
-
|
|
-=== Avoid freeing external data clusters on failure ===
|
|
-
|
|
-Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1024 data_file=TEST_DIR/t.IMGFMT.data_file
|
|
-write failed: Input/output error
|
|
-No errors were found on the image.
|
|
*** done
|
|
diff --git a/tests/qemu-iotests/026.out.nocache b/tests/qemu-iotests/026.out.nocache
|
|
index 8d5001648a..9359d26d7e 100644
|
|
--- a/tests/qemu-iotests/026.out.nocache
|
|
+++ b/tests/qemu-iotests/026.out.nocache
|
|
@@ -661,10 +661,4 @@ wrote 1024/1024 bytes at offset 0
|
|
1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
write failed: Input/output error
|
|
No errors were found on the image.
|
|
-
|
|
-=== Avoid freeing external data clusters on failure ===
|
|
-
|
|
-Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1024 data_file=TEST_DIR/t.IMGFMT.data_file
|
|
-write failed: Input/output error
|
|
-No errors were found on the image.
|
|
*** done
|
|
diff --git a/tests/qemu-iotests/289 b/tests/qemu-iotests/289
|
|
new file mode 100755
|
|
index 0000000000..1c11d4030e
|
|
--- /dev/null
|
|
+++ b/tests/qemu-iotests/289
|
|
@@ -0,0 +1,89 @@
|
|
+#!/usr/bin/env bash
|
|
+#
|
|
+# qcow2 v3-exclusive error path testing
|
|
+# (026 tests paths common to v2 and v3)
|
|
+#
|
|
+# Copyright (C) 2020 Red Hat, Inc.
|
|
+#
|
|
+# This program is free software; you can redistribute it and/or modify
|
|
+# it under the terms of the GNU General Public License as published by
|
|
+# the Free Software Foundation; either version 2 of the License, or
|
|
+# (at your option) any later version.
|
|
+#
|
|
+# This program is distributed in the hope that it will be useful,
|
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
+# GNU General Public License for more details.
|
|
+#
|
|
+# You should have received a copy of the GNU General Public License
|
|
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
+#
|
|
+
|
|
+seq=$(basename $0)
|
|
+echo "QA output created by $seq"
|
|
+
|
|
+status=1 # failure is the default!
|
|
+
|
|
+_cleanup()
|
|
+{
|
|
+ _cleanup_test_img
|
|
+ rm "$TEST_DIR/blkdebug.conf"
|
|
+ rm -f "$TEST_IMG.data_file"
|
|
+}
|
|
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
+
|
|
+# get standard environment, filters and checks
|
|
+. ./common.rc
|
|
+. ./common.filter
|
|
+. ./common.pattern
|
|
+
|
|
+_supported_fmt qcow2
|
|
+_supported_proto file
|
|
+# This is a v3-exclusive test;
|
|
+# As for data_file, error paths often very much depend on whether
|
|
+# there is an external data file or not; so we create one exactly when
|
|
+# we want to test it
|
|
+_unsupported_imgopts 'compat=0.10' data_file
|
|
+
|
|
+echo
|
|
+echo === Avoid freeing external data clusters on failure ===
|
|
+echo
|
|
+
|
|
+cat > "$TEST_DIR/blkdebug.conf" <<EOF
|
|
+[inject-error]
|
|
+event = "write_aio"
|
|
+errno = "5"
|
|
+once = "on"
|
|
+EOF
|
|
+
|
|
+# Test what happens when there is an error when writing to an external
|
|
+# data file instead of when writing to a preallocated zero cluster
|
|
+_make_test_img -o "data_file=$TEST_IMG.data_file" 64k
|
|
+
|
|
+# Put blkdebug above the data-file, and a raw node on top of that so
|
|
+# that blkdebug will see a write_aio event and emit an error. This
|
|
+# will then trigger the alloc abort code, which we want to test here.
|
|
+$QEMU_IO -c "write 0 64k" \
|
|
+ "json:{
|
|
+ 'driver': 'qcow2',
|
|
+ 'file': { 'driver': 'file', 'filename': '$TEST_IMG' },
|
|
+ 'data-file': {
|
|
+ 'driver': 'raw',
|
|
+ 'file': {
|
|
+ 'driver': 'blkdebug',
|
|
+ 'config': '$TEST_DIR/blkdebug.conf',
|
|
+ 'image': {
|
|
+ 'driver': 'file',
|
|
+ 'filename': '$TEST_IMG.data_file'
|
|
+ }
|
|
+ }
|
|
+ }
|
|
+ }" \
|
|
+ | _filter_qemu_io
|
|
+
|
|
+_check_test_img
|
|
+
|
|
+# success, all done
|
|
+echo "*** done"
|
|
+rm -f $seq.full
|
|
+status=0
|
|
diff --git a/tests/qemu-iotests/289.out b/tests/qemu-iotests/289.out
|
|
new file mode 100644
|
|
index 0000000000..e54e2629d4
|
|
--- /dev/null
|
|
+++ b/tests/qemu-iotests/289.out
|
|
@@ -0,0 +1,8 @@
|
|
+QA output created by 289
|
|
+
|
|
+=== Avoid freeing external data clusters on failure ===
|
|
+
|
|
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=65536 data_file=TEST_DIR/t.IMGFMT.data_file
|
|
+write failed: Input/output error
|
|
+No errors were found on the image.
|
|
+*** done
|
|
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
|
|
index cddae00ded..07ce9c2249 100644
|
|
--- a/tests/qemu-iotests/group
|
|
+++ b/tests/qemu-iotests/group
|
|
@@ -291,4 +291,5 @@
|
|
280 rw migration quick
|
|
281 rw quick
|
|
284 rw
|
|
+289 rw quick
|
|
291 rw quick
|
|
--
|
|
2.27.0
|
|
|